//
//	E-DICALL?.DATEBstudiophtmlɕϊ
//	Borland C++ 5.5p
//
//	gF
//		EdicConv DATt@C htmlt@C
//	F
//		EdicConv ALL1.DAT ALL1.html
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define	BUFSIZE 40960
#define	MAXLEN 256

int	buf1[BUFSIZE];
int	buf2[BUFSIZE];
char	buf3[BUFSIZE];
char	e_midashi[BUFSIZE];
char	j_midashi[BUFSIZE];
char	yakubun[BUFSIZE];
char	kana[BUFSIZE];
char	kanji[BUFSIZE];

const	char	*Kakko1 = "m";
const	char	*Kakko2 = "n";
const	char	*Maru = "B";
const	char	*Kaisetsu = "kFi";

//
//	ISO 8879GeBeB
//
struct	{
	unsigned	char	code;
	const	char	*entity;
} Tbl[] = {
	0x9f,	"&aacute;",
	0xa0,	"&agrave;",
	0xa1,	"&Aacute;",
	0xa2,	"&cacute;",
	0xa3,	"&eacute;",
	0xa4,	"&egrave;",
	0xa5,	"&Eacute;",
	0xa6,	"&iacute;",
	0xa7,	"&igrave;",
	0xa8,	"&Iacute;",
	0xa9,	"&nacute;",
	0xaa,	"&oacute;",
	0xab,	"&ograve;",
	0xac,	"&uacute;",
	0xad,	"&ugrave;",
	0xae,	"&ntilde;",
	0xaf,	"&amacr;",
	0xb0,	"&acirc;",
	0xb1,	"&icirc;",
	0xb2,	"&ocirc;",
	0xb3,	"&ccaron;",
	0xb4,	"&rcaron;",
	0xb5,	"&scaron;",
	0xb6,	"&zcaron;",
	0xb7,	"&Zcaron;",
	0xb8,	"&umacr;",
	0xb9,	"&imacr;",
	0xba,	"&auml;",
	0xbb,	"&euml;",
	0xbc,	"&iuml;",
	0xbd,	"&ouml;",
	0xbe,	"&uuml;",
	0xbf,	"&ccedil;",
	0xc1,	"&aring;",
	0xc2,	"&Aring;",
	0xc3,	"&uring;",
	0xc5,	"&scaron;",
	0xc6,	"&lstrok;",
	0xc7,	"&icirc;",
	0xc8,	"&ecirc;",
	0xc9,	"&scedil;",
	0xcb,	"&Ccaron;",
	0xcc,	"&yacute;",
	0xcd,	"&yuml;",
	0xce,	"&cedil;",
	0,	""
};

//
//	CfbNXt@C
//

int
MakeIndexFile( const char *DatFile, const char *IdxFile )
{
	FILE	*fp1, *fp2;
	int 	i, n;
	int	loc, size;

	fp1 = fopen( DatFile, "rb" );
	if ( fp1 == 0 ) return 1;
	fp2 = fopen ( IdxFile, "w" );
	if ( fp2 == 0 ) return 1;

	fread( &n, 4, 1, fp1 );
	fprintf( fp2, "%d\n", n );
	for ( i = 0; i < n; i++ ){
		fread( &loc, 4, 1, fp1 );
		fread( &size, 4, 1, fp1 );
		fprintf( fp2, "%d %d\n", loc, size );
	}

	fclose( fp1 );
	fclose( fp2 );

	return 0;
}

//
//	GfBA̕ϊ
//
int
endian( int a )
{
	char	c[4];
	char	w;
	
	memcpy( c, &a, 4 );
	w = c[0]; c[0] = c[3]; c[3] = w;
	w = c[1]; c[1] = c[2]; c[2] = w;
	
	return *((int *)c);
}

//
//	
//
void
decode( int *crypt, int *plain, int len )
{
	int	i;

	i = 0;
	while( i < len ){
		if ( len - i >= 4 ){
			plain[i/4] = endian( 0x317b1731 - endian(crypt[i/4]) );
			i += 4;
		} else {
			
			plain[i/4] = endian( 0xffffffff - endian(crypt[i/4]) );
			i += 4;
		}
	}
	plain[i/4] = 0;
}

//
//	̔
//
bool
kanji1( unsigned char c )
{
	if ( ( c >= 0x81 && c <= 0x9f )
	  || ( c >= 0xe0 && c <= 0xef ) ) return true;
	return false;
}
bool
kanji2( unsigned char c )
{
	if ( ( c >= 0x40 && c <= 0x7e )
	  || ( c >= 0x80 && c <= 0xfc ) ) return true;
	return false;
}


//
//	OISO 8879̒`ɕϊ
//
void
gaiji( char *intext, char *outtext )
{
	unsigned char	*p, *pp, *q, *r;
	unsigned char	code;
	int	kf;	// tO
	int	i;

	p = (unsigned char*)intext;
	q = (unsigned char*)outtext;
	kf = 0;
	while( *p ){
		// 1oCg?
		if ( !kanji1( *p ) ){
			*q++ = *p++;
			kf = 0;
			continue;
		}

		// 1oCgڂ0x88łȂ
		if ( *p != 0x88 ){
			*q++ = *p++;
			*q++ = *p++;
			kf = 1;
			continue;
		}

		// 1oCgڂ0x88őOオł͂Ȃ 
		if ( !kf && !kanji1(*(p+2)) ){
			i = 0;
			pp = p + 1;
			while( ( code = Tbl[i].code ) != 0 ){
				if ( code == *pp ){
					r = (unsigned char*)Tbl[i].entity;
					while( *r ){
						*q++ = *r++;
					}
					p += 2;
					goto L1;
				}
				i++;
			}
		}
		*q++ = *p++;
		*q++ = *p++;
L1:		kf = 1;
	}
	*q = 0;
}

//
//	htmlLqɕϊ
//
void
convhtml( char *intxt, int size, FILE *fp )
{
	int	i, j, k;
	int	fe;	// pꌩoLtO
	int	fj;	// {ꌩoLtO
	int	fy;	// 󕶁EpLtO
	char	*p, *q;


	i = 0;
	fe = 0;
	fj = 0;
	fy = 0;

	/* pꌩo */
	j = 0;
	while( i < size && intxt[i] != 0x0d ){
		if ( intxt[i] == 0x0a ) continue;
		buf3[j++] = intxt[i++];
		fe = 1;
	}
	buf3[j] = 0;
	gaiji( buf3, e_midashi );
	i++;	// sǂݔ΂

	/* {ꌩo^{ */
	j = 0;
	while( i < size && intxt[i] != 0x0d ){
		if ( intxt[i] == 0x0a ) continue;
		j_midashi[j++] = intxt[i++];
		fj = 1;
	}
	j_midashi[j] = 0;
	i++;	// sǂݔ΂

	/* 󕶁^p */
	j = 0;
	k = 0;
	while( i < size ){
		if ( intxt[i] == 0x0a ) continue;
		/* s?  */
		if ( intxt[i] == 0x0d ){
			if ( i >= size -1 ){
				/* Ō̉s */
				break;
			} else {
				buf3[j++] = '\n';
				k = 0;
				i++;
			}
		} else {
			buf3[j++] = intxt[i++];
			k++;
		}
		/*  */
		if ( k >= MAXLEN && i < size - 2 ){
			/* _ */
			if ( intxt[i] == Maru[0] && intxt[i+1] == Maru[1] ){
				buf3[j++] = intxt[i++];
				buf3[j++] = intxt[i++];
				buf3[j++] = '\n';
				k = 0;
				continue;
			} else 
			/* pXy[X */
			if ( intxt[i] == ' ' ){
				buf3[j++] = intxt[i++];
				buf3[j++] = '\n';
				k = 0;
				continue;
			}
		}
		fy = 1;
	}
	buf3[j] = 0;
	gaiji( buf3, yakubun );

	/* {ꌩo */
	if ( fj ){
		/*  */
		p = j_midashi;
		q = kana;
		while( *p ){
			if ( *p == Kakko1[0] && *(p+1) == Kakko1[1] ){
				p += 2;
				break;
			}
			*q++ = *p++;
		}
		*q = 0;
		q = kanji;
		while( *p ){
			if ( *p == Kakko2[0] && *(p+1) == Kakko2[1] ){
				break;
			}
			*q++ = *p++;
		}
		*q = 0;
	}

	/* po + ao() + (ᕶ) */
	if ( fe && fj && fy ){
		if ( strncmp( yakubun, Kaisetsu, 10 ) == 0 ){
			/*  */
			yakubun[strlen(yakubun) - 4] = 0;
			fprintf( fp, "<dt>%s</dt>\n", yakubun + 10 );
			fprintf( fp, "<dd>%s<br>%s</dd>\n", e_midashi, j_midashi );
		} else {
			fprintf( fp, "<dt>%s</dt>\n", e_midashi );
			fprintf( fp, "<dd>%s<br>\n", j_midashi );
			fprintf( fp, "%s</dd>\n", yakubun );
		}
	} else
	
	/* po + ao() */
	if ( fe && fj && !fy ){
		fprintf( fp, "<dt>%s</dt>\n", e_midashi );
		if ( *kana ){
			fprintf( fp, "<key type=\"\">%s</key>\n", kana );
			fprintf( fp, "<key type=\"NX\">%s</key>\n", kana );
		}
		if ( *kanji ){
			fprintf( fp, "<key type=\"\L\">%s</key>\n", kanji );
			fprintf( fp, "<key type=\"NX\">%s</key>\n", kanji );
		}
		fprintf( fp, "<dd>%s</dd>\n", j_midashi );
	} else
	
	/* po + (ᕶ) */
	if ( fe && !fj && fy ){
		fprintf( fp, "<dt>%s</dt>\n", e_midashi );
		fprintf( fp, "<dd>%s</dd>\n", yakubun );
	} else
	
	/* ao +  */
	if ( !fe && fj && fy ){
		fprintf( fp, "<dt>%s</dt>\n", j_midashi );
		fprintf( fp, "<dd>%s</dd>\n", yakubun );
	} 
}

//
//	htmlt@C
//
int
MakeHtmlFile( const char *DatFile, const char *IdxFile, const char *HtmlFile )
{
	FILE	*fp1, *fp2, *fp3;
	int	n;		// f[^
	int	i;
	int	pos, size;	// f[^̈ʒuƃTCY
	
	fp1 = fopen( DatFile, "rb" );
	if ( fp1 == 0 ) return 1;
	
	fp2 = fopen( IdxFile, "r" );
	if ( fp2 == 0 ) return 1;
	
	fp3 = fopen( HtmlFile, "w" );
	if ( fp3 == 0 ) return 1;
	
	fscanf( fp2, "%d", &n );
	printf( "n=%d\n", n );
	
	fprintf( fp3, "<html>\n" );
        fprintf( fp3, "<head>\n" );
        fprintf( fp3, "<title> E-DIC </title>\n" );
        fprintf( fp3, "</head>\n" );
        fprintf( fp3, "<body>\n" );
        fprintf( fp3, "<dl>\n" );
        
	for ( i = 0; i < n; i++ ){
		/* CfbNXǂ */
		fscanf( fp2, "%d %d", &pos, &size );
		
		/* {ǂ */
		fseek( fp1, pos, SEEK_SET );
		fread( buf1, size, 1, fp1 );

		/*  */
		decode( buf1, buf2, size );

		/* html`ɕϊ */
		convhtml( (char*)buf2, size, fp3 );

	}

        fprintf( fp3, "</dl>\n" );
        fprintf( fp3, "</body>\n" );
        fprintf( fp3, "</html>\n" );
	
	fclose( fp1 );
	fclose( fp2 );
	fclose( fp3 );
	
	return 0;
}

//
//	C
//
main( int argc, char *argv[] )
{
	int	st;

	if ( argc == 1 ){
		printf( "usage:\n" );
		printf( "    conv DAT_file\n" );
		return 1;
	}
	st = MakeIndexFile( argv[1], "IDX" );
	if ( st ) return 1;
	
	st = MakeHtmlFile( argv[1], "IDX", argv[2] );
	if ( st ) return 1;

	return 0;
}